/*
 * This file and its contents are supplied under the terms of the
 * Common Development and Distribution License ("CDDL"), version 1.0.
 * You may only use this file in accordance with the terms of version
 * 1.0 of the CDDL.
 *
 * A full copy of the text of the CDDL should have accompanied this
 * source.  A copy of the CDDL is also available via the Internet at
 * http://www.illumos.org/license/CDDL.
 */

/*
 * Copyright 2012 David Hoeppner.  All rights reserved.
 */

#ifndef	_NETINET_DCCP_H
#define	_NETINET_DCCP_H

#ifdef	__cplusplus
extern "C" {
#endif

/*
 * DCCP header
 */
struct dccphdr {
	uint16_t	dh_sport;
	uint16_t	dh_dport;
	uint8_t		dh_offset;
#ifdef _BIT_FIELDS_LTOH
	uint8_t		dha_ccval:4,
			dha_cscov:4;
#else
	uint8_t		dha_cscov:4,
			dha_ccval:4;
#endif
	uint16_t	dha_sum;
#ifdef _BIT_FIELDS_LTOH
	uint8_t		dha_x:1,
			dha_type:4,
			dha_reserved:3;
#else
	uint8_t		dha_reserved:3,
			dha_type:4,
			dha_x:1;
#endif
	uint8_t		dha_res_seq;
	uint16_t	dha_seq;
};

/*
 * DCCP states
 */
#define	DCCPS_CLOSED	-5
#define	DCCPS_IDLE	-5
#define	DCCPS_BOUND	-4
#define	DCCPS_LISTEN	-3
#define	DCCPS_REQUEST	-2
#define	DCCPS_REQUEST_SENT	-2
#define	DCCPS_REQUEST_RCVD	-2
#define	DCCPS_RESPOND	-1
#define	DCCPS_ACK_RCVD	-1
#define	DCCPS_PARTOPEN	0
#define	DCCPS_ACK_SENT		1
#define	DCCPS_ESTABLISHED	2


#ifdef	__cplusplus
}
#endif

#endif	/* _NETINET_DCCP_H */
